#include "xbasic_types.h"
#include "xio.h"
#include "xintc_l.h"
#include "xuartlite_l.h"
#include "xparameters.h"
#include "flash.h"
#include "menu.h"

void FlashOut();
void FlashRecord();
volatile int j=1;
volatile int k=5;
volatile int flag=0;
extern volatile int out_enable;

// Write a text string on the display
void put_string(char *string, int row, int column)
{
  char *p = &(CHAR(row, column));
  while (*p++ = *string++)
    ;
}

void putMenu()
{
  char space_array[26]="                          ";
  volatile unsigned char *p;
  for ( p = &(CHAR(0,0)) ; p < &(CHAR(29,80)) ; ++p)		//clear VGA screen
     *p = ' ';
  put_string("INTERNET RADIO", 3, 30);				//display menu items
  put_string("1. Live Broadcast             ", 5, 27);
  put_string("2. Advertisement Insertion    ", 7,27 );
  put_string("3. Utility                    ", 9, 27);
  put_string(space_array, 11, 27);
  put_string(space_array, 13, 27);
  put_string(space_array, 15, 27);
  put_string("  ", k, 24);
  put_string(">>", 5, 24);
  j=1;	//j save the menu item number
  k=5;	//k save the row position for ">>"
}

void vga_menu(char buf)
{

  char space_array[26]="                          ";
  volatile unsigned char *p;

  if (buf==0xd)       	      		 //Enter key
        {

	  switch (j)
	    {
	    case 1:
	      put_string("Enable live broadcast    ", 5, 27);
	      put_string("Disable live broadcast   ", 7, 27);
	      put_string("Return                   ", 9, 27);
	      put_string("  ", k, 24);
	      k=5;
	      put_string(">>", 5, 24);
	      j=4;
	      break;

	    case 2:
	      put_string("Start Ad insertion       ", 5, 27);
	      put_string("Return                   ", 7, 27);
	      put_string(space_array, 9, 27);
	      put_string("  ", k, 24);
	      k=5;
	      put_string(">>", 5, 24);
	      j=7;
	      break;

	    case 3:
	      put_string("Erase Flash buffer       ", 5, 27);
	      put_string("Record Ad to Flash       ", 7, 27);
	      put_string("Return                   ", 9, 27);
	      put_string("  ", k, 24);
	      put_string(">>", 5, 24);
	      k=5;
	      j=9;
	      break;

	    case 4:
	      out_enable=1;
	      break;

	    case 5:
	      out_enable=0;
	      break;

	    case 6:
	      putMenu();
	      break;

	    case 7:
	      for ( p = &(CHAR(25,20)) ; p < &(CHAR(29,80)) ; ++p) *p = ' ';
	      put_string("Playing advertisement now......", 25, 25);
	      FlashOut();
	      put_string("Ad insertion completed", 27, 25);
	      break;

	    case 8:
	      putMenu();
	      break;

	    case 9:
	      for ( p = &(CHAR(25,20)) ; p < &(CHAR(29,80)) ; ++p) *p = ' ';
              put_string("Start erasing flash......", 25, 25);
	      FlashErase();
	      put_string("Flash is empty now", 27, 25);
	      break;

	   case 10:								//record sound to flash

	      for ( p = &(CHAR(25,20)) ; p < &(CHAR(29,80)) ; ++p) *p = ' ';
	      put_string("Erase the entire Flash chip now......", 25, 20);
	      FlashErase();
	      put_string("Record now......", 26, 20);
	      FlashRecord();
	      put_string("Record to Flash successfully", 27, 20);
	      break;

	   case 11:
	      putMenu();
	      break;
	   }

        }
		else  if (buf==0x1b || flag==1)       //Up or Down arrow key
        {
        	flag=1;
		if(buf==0x41)
			{
				if(j!=1 && j!=4 && j!=7 && j!=9) { j--;  put_string("  ", k, 24);  k=k-2; put_string(">>", k, 24);}
				flag=0;
			}
		if(buf==0x42)
			{
				if(j!=3 && j!=6 && j!=8 && j!=11) { j++; put_string("  ", k, 24); k=k+2; put_string(">>", k, 24);}
				flag=0;
			}
        }

 }
